# Python LFSR generator
#
# Original author: David Banas
# Original date:   March 30, 2015
#
# Copyright (c) 2015 David Banas; All rights reserved World wide.

def lfsr_bits(taps, seed):
    """
    """

    val      = int(seed)
    num_taps = max(taps)
    mask     = (1 << num_taps) - 1

    while(True):
        xor_res = reduce(lambda x, b: x ^ b, [bool(val & (1 << tap)) for tap in taps])
        val     = (val << 1) & mask  # Just to keep 'val' from growing without bound.
        if(xor_res):
            val += 1
        yield(val & 1)

